【hdu 5918】Sequence I(KMP)

给定两个数字序列,求a序列中每隔p个构成的p+1个序列中共能匹配多少个b序列。

例如1 1 2 2 3 3 每隔1个的序列有两个1 2 3

kmp,匹配时每次主串往前p个,枚举1到p为起点。

题目

#include<bits/stdc++.h>
#define N 1000005
int t,n,m,p;
int nex[N];
int a[N],b[N];
using namespace std;
void getNext(){
    int i=0,k=-1;
    nex[0]=k;
    while(b[i]){
        while(k!=-1 && b[i]!=b[k])k=nex[k];
        nex[++i]=++k;
    }
}
int KMP(){
    int ans=0;
    for(int q=0;q<p;q++){
        int i=q,j=0;
        while(i<n){
            while(-1!=j && a[i]!=b[j])j=nex[j];
            i+=p;j++;
            if(j>=m){
                ans++;
                j=nex[j];
            }
        }
    //    printf("ans=%d\n",ans);
    }
    return ans;
}
int main(){
    //freopen("1008.in","r",stdin);
    scanf("%d",&t);
    for(int ca=1;ca<=t;ca++){
        memset(a,0,sizeof a);
        memset(b,0,sizeof b);
        memset(nex,0,sizeof nex);
        scanf("%d%d%d",&n,&m,&p);
        for(int i=0;i<n;i++)
            scanf("%d",&a[i]);
        for(int i=0;i<m;i++)
            scanf("%d",&b[i]);
        getNext();
        printf("Case #%d: %d\n",ca,KMP());
    }
}
时间: 2024-10-11 07:01:05

【hdu 5918】Sequence I(KMP)的相关文章

【HDU 4763】Theme Section(KMP)

这题数据水的一B,直接暴力都可以过. 比赛的时候暴力过的,回头按照正法做了一发. 匹配的时候 失配函数 其实就是前缀 后缀的匹配长度,之后就是乱搞了. KMP的题可能不会很直接的出,但是KMP的思想经常渗透在很多题目里面,最近需要多练习一下. #include<cstdio> #include<cstring> #include<algorithm> using namespace std; const int maxn = 1000005; int _next[max

【HDU 3400】Line belt(三分法)

题目链接 题目链接 http://acm.hdu.edu.cn/showproblem.php?pid=3400 题意 有两条传送带AB和CD,移动速度分别为p,q. 除了传送带的其他区域移动速度为r,问A到D最短时间. 题目分析 在AB上找一点E,在CD上找一点F. 使得A->E->F->D时间最短. 数学思路 时间 time = |AE|/p + |EF|/r + |FD|/q. (|AE|为线段AE的长度.) 未知量有E的位置和F的位置,由于确定在AB和CD上,所以只需要两个未知量

【HDU 1533】 Going Home (KM)

Going Home Problem Description On a grid map there are n little men and n houses. In each unit time, every little man can move one unit step, either horizontally, or vertically, to an adjacent point. For each little man, you need to pay a $1 travel f

【HDU 3640】I, zombie (二分)

传送门 题目描述 The "endless" model in "I, zombie" of "Plants vs. Zombies" is my favourite.The aim of the game is to put down the zombies most reasonable in the right-most , to eat the brain protected by Plants in the left-most. To

【HDU 5839】Special Tetrahedron(计算几何)

空间的200个点,求出至少四边相等,且其余两边必须不相邻的四面体的个数. 用map记录距离点i为d的点有几个,这样来优化暴力的四重循环. 别人的做法是枚举两点的中垂面上的点,再把到中点距离相等的点找出来,n^3的样子. 还要注意四个点共面的情况. 共面判断就是用叉乘计算出ijk三点所在面的法向量,然后判断il向量是否和法向量垂直,是则共面. #include <cstdio> #include <cstring> #include <algorithm> #includ

【HDU 5091】Beam Cannon(扫描线)

按照x轴建树,求线段树的区间最值. 模型转化就是: 矩阵最大交 #include<cstdio> #include<cstring> #include<algorithm> using namespace std; #define lson (pos<<1) #define rson (pos<<1|1) const int ADD = 25555; const int maxn = 80005; int n,w,h,cnt; struct Se

【HDU 4445】Crazy Tank(暴力)

高中物理斜抛运动,简单分析一下角度固定下来则可以计算每个cannonball的降落坐标lnd. 因此暴力计算不同角度下的结果. #include <cstdio> #include "cmath" #include "algorithm" #define ll long long #define dd double #define N 205 #define g 9.8 #define eps 1e-6 const dd pi=acos(-1.0); l

【HDU 5335】Walk Out(BFS)

这道题卡时间卡的比较紧. 一开始直接BFS 毫无疑问的超时,之后想到根据BFS的常规优化思想,去选择起始点进行遍历. 这样我们一开始先BFS一次,这次的BFS是选择出这一点为1并且从起点到这一个点,中间路径的点全为0的点. 这样选择出这个点之后,这个点到终点的路径长度就可以断定了. 之后我们把所有到终点距离最小的点放在一个容器里进行BFS. 这道题没有做出来的原因很大一部分就是对BFS的理解不够深以及该有的贪心思路没有,导致了这道题没有AC. 嗯,有句话说的对:综合是第一生产力. #includ

【POJ 3368】 Frequent values(RMQ)

[POJ 3368] Frequent values(RMQ) Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 15813   Accepted: 5749 Description You are given a sequence of n integers a1 , a2 , ... , an in non-decreasing order. In addition to that, you are given seve